
//--------------------------------------------------------------------
//
//          DELL COMPUTER CORPORATION PROPRIETARY INFORMATION
// This software is supplied under the terms of a license agreement or
// nondisclosure agreement with Dell Computer Corporation and may not
// be copied or disclosed except in accordance with the terms of that
// agreement.
//
// Copyright (c) 1995-2004 Dell Computer Corporation. All Rights Reserved.
//
// Module Name:
//
// HAPI Test Porgram
//
// Abstract/Purpose:
//
// Test the HAPI layer
//
// Environment:
//
// User mode only
//
//--------------------------------------------------------------------


//--------------------------------------------------------------------
// Defines to customize headers to follow
//--------------------------------------------------------------------

#if (!defined SYSTEM_DEBUG_LEVEL) && (defined _DEBUG)
#define SYSTEM_DEBUG_LEVEL      3
#endif

//--------------------------------------------------------------------
// Standard C include files
//--------------------------------------------------------------------
#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>

//--------------------------------------------------------------------
// Dell specific headers
//--------------------------------------------------------------------


//--------------------------------------------------------------------
// Local include files
// Function prototypes and other local includes
//--------------------------------------------------------------------

#include <linux/types.h>
#include <signal.h>
#include <gpiotypes.h>
//#include <dcgpio.h>
#include <gpio_struct.h>
#include <gpioiocts.h>
#include <gtsupt.h>
#include <cmc_intr_prototypes.h>


//--------------------------------------------------------------------
// Local Defines
//--------------------------------------------------------------------


//--------------------------------------------------------------------
// Global Data Area
//--------------------------------------------------------------------

// Context Data




//---------------------------------------------------------------------
//  Code Start
//---------------------------------------------------------------------

void sighandler (int sig) {
	hapicleanup();
	signal(SIGINT, SIG_DFL);
	// Kill myself including the threads
	kill(getpid(), SIGINT);
}

//---------------------------------------------------------------------
//  Main
//---------------------------------------------------------------------
int main(int argc, char **argv)
{
	GPIODeviceStruct GpioDevice;
	unsigned char DeviceNameBuf[256];

	// initialize the interfaces that will be tested
	// if command line args passed check them
	if (argc > 1)
	{
		// drop the - sign and concentrate on the symbol
		switch (argv[1][1])
		{
			case 'r':
				// if comport specfied use it else default is com1
				if (argc > 2)
					sprintf(DeviceNameBuf,"\\\\.\\%s",argv[2]);
				else
					sprintf(DeviceNameBuf,"\\\\.\\com1");
			break;

			case 's':
			    dumpstats();
			    exit(0);
			    break;


			case 'h':
			default:
				printf("gpio_test\n");
				return 1;
			break;
		}
	}

	signal(SIGTERM, &sighandler);
	signal(SIGQUIT, &sighandler);
	signal(SIGABRT, &sighandler);
	signal(SIGINT, &sighandler);

	MainMenu(&GpioDevice);

	return 0;
} // main

